﻿Public Class frmHello

    Private Sub Button1_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button1.Click

        'the IP-address must be used
        ComputerIP1="192.168.7.2"
        ComputerIP2="192.168.30.2"

        Debug.Print("")
        Debug.Print("ftRoboRemote, Andreas Gail, 2017")
        Debug.Print("no warrenty, all on your own risk, free of charge")
        Debug.Print("uses ftrobopy, sharpSsh, Magick.NET, check license information first")
        Debug.Print("")

        'check network
        Debug.Print("Ping Computer("& ComputerIP1 &"):" & My.Computer.Network.Ping(ComputerIP1))
        Debug.Print("Ping Computer("& ComputerIP2 &"):" & My.Computer.Network.Ping(ComputerIP2))

        'check hostname before connection
        Debug.Print("hostname 1 (before connection):" & ftRoboRemote.RemoteHostname(1))
        'Debug.Print("hostname 2 (before connection):" & ftRoboRemote.RemoteHostname(2))

        'connect RoboTXT with ssh
        Debug.Print(ftRoboRemote.ConnectTXT(1,ComputerIP1))
        'Debug.Print(ftRoboRemote.ConnectTXT(2,ComputerIP2))

        'check hostname before connection
        Debug.Print("hostname 1 (after connection):" & ftRoboRemote.RemoteHostname(1))
        'Debug.Print("hostname 2 (after connection):" & ftRoboRemote.RemoteHostname(2))

        'read ftrobopy version running in RoboTXT
        Debug.Print("ftrobopy RoboTXT 1 version:" & ftRoboRemote.ftrobopy.version(1))
        'Debug.Print("ftrobopy RoboTXT 2 version:" & ftRoboRemote.ftrobopy.version(2))

        'check if RoboTXT is online
        Debug.Print("RoboTXT 1 is online:" & ftRoboRemote.TXT.isOnline(1))
        'Debug.Print("RoboTXT 2 is online:" & ftRoboRemote.TXT.isOnline(2))

        'read hardware information of RoboTXT
        Debug.Print(ftRoboRemote.TXT.queryStatus(1))                           'must always be called first
        Debug.Print("devicename RoboTXT 1:" & ftRoboRemote.TXT.getDevicename(1))         'hardware name
        Debug.Print("firmware RoboTXT 1 (hex):" & ftRoboRemote.TXT.getVersionNumber(1))   'firmware version (hex)
        Debug.Print("firmware RoboTXT 1 (dec):" & ftRoboRemote.TXT.getFirmwareVersion(1)) 'firmware version (dec)

        Debug.Print("active IP RoboTXT 1:" & ftRoboRemote.TXT.getHost(1))

        MsgBox("for the first test (all on RoboTXT 1): connnect a drive to M1")

        'define RoboTXT output
        Debug.Print(ftRoboRemote.TXT.M(1,ftRoboRemote.TXT.C_MOTOR,ftRoboRemote.TXT.C_MOTOR,ftRoboRemote.TXT.C_OUTPUT,ftRoboRemote.TXT.C_OUTPUT))

        'define RoboTXT input
        Debug.Print(ftRoboRemote.TXT.I(1,ftRoboRemote.TXT.C_SWITCH,ftRoboRemote.TXT.C_DIGITAL,ftRoboRemote.TXT.C_SWITCH,ftRoboRemote.TXT.C_DIGITAL,ftRoboRemote.TXT.C_ULTRASONIC,ftRoboRemote.TXT.C_ANALOG,ftRoboRemote.TXT.C_VOLTAGE,ftRoboRemote.TXT.C_ANALOG,ftRoboRemote.TXT.C_RESISTOR,ftRoboRemote.TXT.C_ANALOG,ftRoboRemote.TXT.C_SWITCH,ftRoboRemote.TXT.C_DIGITAL,ftRoboRemote.TXT.C_SWITCH,ftRoboRemote.TXT.C_DIGITAL,ftRoboRemote.TXT.C_SWITCH,ftRoboRemote.TXT.C_DIGITAL))

        'write RoboTXT into parameter variables
        Debug.Print(ftRoboRemote.TXT.setConfig(1))

        'use new parameter variables
        Debug.Print(ftRoboRemote.TXT.updateConfig(1))

'GoTo jump1
        
        'set parameter O1=0 and O2=512 (M1=turning left), this definition starts the drive now
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,512))
                    
        System.Threading.Thread.Sleep(3000)

        'set parameter O1=0 and O2=0 (M1=stop), this definition stops the drive now
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))

        System.Threading.Thread.Sleep(100)

        'set parameter O1=512 and O2=0 (M1=turning right), this definition starts the drive now
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,512))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))

        System.Threading.Thread.Sleep(3000)

        'stop all outputs, they has to be set again for a new start
        Debug.Print(ftRoboRemote.TXT.stopAll(1))

        System.Threading.Thread.Sleep(1000)

        'ramp up O2 from 0 to 512 in 5 seconds (M1 equivalent to I1 and I2)
        'remember: after stopAll the outputs has to be set again for a new start
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))
        Debug.Print(ftRoboRemote.TXT.setPwmRamp(1,1,0,512,5))

        'no new definition for O1
        'ramp down O2 from 0 to 512 in 5 seconds (M1)
        Debug.Print(ftRoboRemote.TXT.setPwmRamp(1,1,512,0,5))

        MsgBox("for the next test (all on RoboTXT 1): connect encoder plug for drive M1, rotation for 200 steps (two times)")

        'define drive M1 for 200 steps, this definition will not start the drive
        Debug.Print(ftRoboRemote.TXT.setMotorDistance(1,1,200))

        'define the speed an rotation direction of drive M1, this definition will not start the drive
        'the output pins O1 und O2 (=M1) has to be set
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,512))

        'start rotation of drive M1
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,1))

        System.Threading.Thread.Sleep(1000)

        'start rotation of drive M1
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,1))

        MsgBox("for the next test (all on RoboTXT 1): the encoder mode of drive M1 has to be reset")

        'reset of the encoder mode to run drive M1 permanent
        Debug.Print(ftRoboRemote.TXT.setMotorDistance(1,1,0))

        'start drive M1 again
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,512))

        'define sound number (3) in RoboTXT as active sound
        Debug.Print(ftRoboRemote.TXT.setSoundIndex(1,3))

        'define number of repetition (2x)
        'if set to 0 then endless repetition, can terminated by set to 1
        Debug.Print(ftRoboRemote.TXT.setSoundRepeat(1,2))

        'play defined sound
        Debug.Print(ftRoboRemote.TXT.incrSoundCmdId(1))

        MsgBox("for the next test (all on RoboTXT 1): syncronous encoder mode for two drives M1 and M2")

        'stop drive M1 from previous test
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))

        'wait 2 seconds
        System.Threading.Thread.Sleep(2000)

        'define drive M1 is slave and has to follow its master drive M2
        Debug.Print(ftRoboRemote.TXT.setMotorSyncMaster(1,1,2))
        'define drive M2 is slave and has to follow its master drive M1
        Debug.Print(ftRoboRemote.TXT.setMotorSyncMaster(1,2,1))

        'prepare action
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,1))
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,2))

        'start drives M1 and M2
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,3,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,512))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,4,512))

        MsgBox("for the next test (all on RoboTXT 1): syncronous encoder mode, speed reduction of drive M1 and acceleration again, drive M2 follows M1")

        'reduce speed of master drive M1 (=O2)
        Debug.Print(ftRoboRemote.TXT.setPwmRamp(1,2,512,15,10))

        'wait 2 seconds without change
        System.Threading.Thread.Sleep(2000)

        'ramp up speed of master drive M1 (=O2)
        Debug.Print(ftRoboRemote.TXT.setPwmRamp(1,2,15,512,10))

        MsgBox("for the next test (all on RoboTXT 1): reset of master-slave relations of drive M1 and M2")

        'stop drive M1 and M2 from previous test
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,3,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,4,0))

        'wait 2 seconds
        System.Threading.Thread.Sleep(2000)

        'reset of master-slave relations of drive M1
        Debug.Print(ftRoboRemote.TXT.setMotorSyncMaster(1,1,0))
        'reset of master-slave relations of drive M2
        Debug.Print(ftRoboRemote.TXT.setMotorSyncMaster(1,2,0))

        'prepare action
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,1))
        Debug.Print(ftRoboRemote.TXT.incrMotorCmdId(1,2))

        'start drive M1
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,512))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,0))

        MsgBox("for the next test (all on RoboTXT 1): connnect a push-button to I1 and GND")

        For n=1 to 50
            Debug.Print("push-button(I1)=" & ftRoboRemote.TXT.getCurrentInput(1,1))
            System.Threading.Thread.Sleep(200)
        Next n

        MsgBox("for the next test (all on RoboTXT 1): connnect photo sensor to I5 and GND")

        For n=1 to 50
            Debug.Print("photo sensor(I5)=" & ftRoboRemote.TXT.getCurrentInput(1,5))
            System.Threading.Thread.Sleep(200)
        Next n

        MsgBox("for the next test (all on RoboTXT 1): connnect ultrasonic sensor to I3")

        For n=1 to 50
            Debug.Print("ultrasonic sensor(I3)=" & ftRoboRemote.TXT.getCurrentInput(1,3))
            System.Threading.Thread.Sleep(200)
        Next n

        'show all input values I1...8
        Debug.Print(ftRoboRemote.TXT.getCurrentInput(1,0))
        Debug.Print("  Input 1=" & ftRoboRemote.TXT.getCurrentInputResult.In1)
        Debug.Print("  Input 2=" & ftRoboRemote.TXT.getCurrentInputResult.In2)
        Debug.Print("  Input 3=" & ftRoboRemote.TXT.getCurrentInputResult.In3)
        Debug.Print("  Input 4=" & ftRoboRemote.TXT.getCurrentInputResult.In4)
        Debug.Print("  Input 5=" & ftRoboRemote.TXT.getCurrentInputResult.In5)
        Debug.Print("  Input 6=" & ftRoboRemote.TXT.getCurrentInputResult.In6)
        Debug.Print("  Input 7=" & ftRoboRemote.TXT.getCurrentInputResult.In7)
        Debug.Print("  Input 8=" & ftRoboRemote.TXT.getCurrentInputResult.In8)

        MsgBox("for the next test (all on RoboTXT 1): trigger counters to set values")

        'show counter value C2
        Debug.Print("counter(C2)=" & ftRoboRemote.TXT.getCurrentCounterValue(1,2))

        'show all counter values C1...4
        Debug.Print(ftRoboRemote.TXT.getCurrentCounterValue(1,0))
        Debug.Print("  Counter 1=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter1)
        Debug.Print("  Counter 2=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter2)
        Debug.Print("  Counter 3=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter3)
        Debug.Print("  Counter 4=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter4)

        'set all counter values to 0
        Debug.Print(ftRoboRemote.TXT.incrCounterCmdId(1,1))
        Debug.Print(ftRoboRemote.TXT.incrCounterCmdId(1,2))
        Debug.Print(ftRoboRemote.TXT.incrCounterCmdId(1,3))
        Debug.Print(ftRoboRemote.TXT.incrCounterCmdId(1,4))

        'show all counter values C1...4
        Debug.Print(ftRoboRemote.TXT.getCurrentCounterValue(1,0))
        Debug.Print("  Counter 1=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter1)
        Debug.Print("  Counter 2=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter2)
        Debug.Print("  Counter 3=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter3)
        Debug.Print("  Counter 4=" & ftRoboRemote.TXT.getCurrentCounterValueResult.Counter4)

        MsgBox("for the next test (all on RoboTXT 1): take a ft IR remote control and play with it")

        For n=1 to 50
            Debug.Print("IR remote control:" & ftRoboRemote.TXT.getCurrentIr(1))
            'Debug.Print("  01=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field01)
            'Debug.Print("  02=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field02)
            'Debug.Print("  03=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field03)
            'Debug.Print("  04=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field04)
            'Debug.Print("  05=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field05)
            'Debug.Print("  06=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field06)
            'Debug.Print("  07=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field07)
            'Debug.Print("  08=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field08)
            'Debug.Print("  09=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field09)
            'Debug.Print("  10=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field10)
            'Debug.Print("  11=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field11)
            'Debug.Print("  12=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field12)
            'Debug.Print("  13=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field13)
            'Debug.Print("  14=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field14)
            'Debug.Print("  15=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field15)
            'Debug.Print("  16=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field16)
            'Debug.Print("  17=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field17)
            'Debug.Print("  18=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field18)
            'Debug.Print("  19=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field19)
            'Debug.Print("  20=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field20)
            'Debug.Print("  21=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field21)
            'Debug.Print("  22=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field22)
            'Debug.Print("  23=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field23)
            'Debug.Print("  24=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field24)
            'Debug.Print("  25=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field25)
            'Debug.Print("  26=" & ftRoboRemote.TXT.getCurrentIrResult.raw.field26)
            Debug.Print("  Pdl_00_LH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LH)
            Debug.Print("  Pdl_00_LV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_LV)
            Debug.Print("  Pdl_00_RH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RH)
            Debug.Print("  Pdl_00_RV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_00_RV)
            Debug.Print(" ")
            Debug.Print("  Pdl_10_LH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LH)
            Debug.Print("  Pdl_10_LV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_LV)
            Debug.Print("  Pdl_10_RH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RH)
            Debug.Print("  Pdl_10_RV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_10_RV)
            Debug.Print(" ")
            Debug.Print("  Pdl_01_LH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LH)
            Debug.Print("  Pdl_01_LV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_LV)
            Debug.Print("  Pdl_01_RH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RH)
            Debug.Print("  Pdl_01_RV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_01_RV)
            Debug.Print(" ")
            Debug.Print("  Pdl_11_LH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LH)
            Debug.Print("  Pdl_11_LV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_LV)
            Debug.Print("  Pdl_11_RH:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RH)
            Debug.Print("  Pdl_11_RV:" & ftRoboRemote.TXT.getCurrentIrResult.processed.Pdl_11_RV)
            Debug.Print(" ")

            System.Threading.Thread.Sleep(1000)
        Next n

jump1:
        MsgBox("for the next test (all on RoboTXT 1): plug in the ft USB camera into the RoboTXT")

        For n=1 to 10

            'try to catch an image with RoboTXT camera, this image will be stored on the RoboTXT
            Debug.Print(ftRoboRemote.TXT.startCameraOnline(1))
            Debug.Print(ftRoboRemote.TXT.getCameraFrame(1))
            Debug.Print(ftRoboRemote.TXT.stopCameraOnline(1))

            'copy the image from the RoboTXT to an other location which direct access from Visual Basic
            Debug.Print(ftRoboRemote.transferPicture(1,ComputerIP1,"C:\"))

            'check the transfered image if it seems to be OK, sometimes the file has only some bytes and
            'it is not a picture; the RoboTXT made an error in that case
            'if there in an error likely a complete retry is done with all camera operation
            If Microsoft.VisualBasic.Strings.Right(ftRoboRemote.checkPicture("C:\txtimg.jpg"),2)="OK" then
                n=10
                frmTxtCam.Show
                frmTxtCam.Activate
            else
                Debug.Print("retry " & n & " to get image from RoboTXTs camera")
            End If

        Next n

        MsgBox("for the next test (all on RoboTXT 1): connnect a drive to M1 to that it still works")

        'set parameter O1=0 and O2=512 (M1=turning left), this definition starts the drive now
        Debug.Print(ftRoboRemote.TXT.setPwm(1,1,0))
        Debug.Print(ftRoboRemote.TXT.setPwm(1,2,512))

        'MsgBox("for the next test (now on RoboTXT 2): connnect a push-button to I1 and GND")

        For n=1 to 50
            'Debug.Print("push-button(I1)=" & ftRoboRemote.TXT.getCurrentInput(2,1))
            'System.Threading.Thread.Sleep(200)
        Next n

        MsgBox("so that's all")

        'close connection
        Debug.Print(ftRoboRemote.CloseTXT(1))
        'Debug.Print(ftRoboRemote.CloseTXT(2))

        'check hostname after closing connection
        Debug.Print("hostname 1 (after closing connection):" & ftRoboRemote.RemoteHostname(1))
        Debug.Print("hostname 2 (after closing connection):" & ftRoboRemote.RemoteHostname(2))
        
    End Sub

    Private Sub frmHello_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
        For n=1 to ftRoboRemote.MaxConnect
            ftRoboRemote.RemoteHostname(n)="not defined"
        Next n
    End Sub

    Private Sub Button2_Click_1( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Button2.Click
        frmWebCam.show
    End Sub

End Class
